#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include"save.h"


int CountFound(Player thePlayer, LevelList theList)
{
 int Gems = 0;
 
 theList.Current = theList.Head;
 
 while(theList.Current != NULL)
 {
  thePlayer.traverse = thePlayer.head;	
 
  while (thePlayer.traverse != NULL) 
  {
   if(thePlayer.traverse->ID == theList.Current->theLevel.ID)
   {
    Gems += theList.Current->theLevel.NumberOfGems;	
   }
   thePlayer.traverse = thePlayer.traverse->next;
  }		
  theList.Current = theList.Current->next;
 }
	
 return Gems;	
 	
}

int Count(Player thePlayer)
{
 int Nodes = 0;
 
 thePlayer.traverse = thePlayer.head;	
 
 while (thePlayer.traverse != NULL) 
 {
  Nodes++;
  thePlayer.traverse = thePlayer.traverse->next;
 }		
	
 return Nodes;	
}

int FindLevel(Player thePlayer, int ID)
{
 thePlayer.traverse = thePlayer.head;	
 
 while (thePlayer.traverse != NULL) 
 {
  if(thePlayer.traverse->ID == ID)
  {
   return thePlayer.traverse->Moves;
  }
  thePlayer.traverse = thePlayer.traverse->next;
 }		
	
 return 0;	
}

Player EnterData(int ID, int Moves, Player thePlayer)
{
 thePlayer.traverse = thePlayer.head;	
 
 while (thePlayer.traverse != NULL) 
 {
  if(thePlayer.traverse->ID == ID)
  {
   if(thePlayer.traverse->Moves > Moves)
     thePlayer.traverse->Moves = Moves;
   return thePlayer;
  }
  thePlayer.traverse = thePlayer.traverse->next;
 }		
	
 thePlayer = add( thePlayer, ID, Moves);
 return thePlayer;
}

void WritePlayer(Player thePlayer)
{
 char* FileName = "       ";
 int i;
 
 for(i = 0; i < 3; i++)         
 {                               
  FileName[i] = thePlayer.name[i];
 }		
 FileName[3] = '.';
 FileName[4] = 'p';
 FileName[5] = 'l';
 FileName[6] = 'h';
 
 FILE* NewPlayer = fopen(FileName,"w");
 	
 thePlayer.traverse = thePlayer.head;	
 
  while (thePlayer.traverse != NULL) 
 {
  fprintf(NewPlayer, "L%d\n", thePlayer.traverse->ID);
  fprintf(NewPlayer, "%d\n", thePlayer.traverse->Moves);	
  
  thePlayer.traverse = thePlayer.traverse->next;
 }	
 fclose(NewPlayer);
}

void freelist(Player thePlayer) 
{
 WritePlayer(thePlayer);

 thePlayer.traverse = thePlayer.head;

 while (thePlayer.head != NULL) 
 {
  
  thePlayer.traverse = thePlayer.head->next;
  free(thePlayer.head);
  thePlayer.head = thePlayer.traverse;
 }
}

Player add(Player thePlayer, int nextID, int nextMoves) 
{
 Node* newNode;
 
 newNode= malloc(200);
 newNode->ID = nextID;
 newNode->Moves = nextMoves;
 newNode->next = NULL;
 newNode->prev = NULL;
 
 if (thePlayer.head == NULL)
 {
  thePlayer.head = newNode ;
  thePlayer.traverse = thePlayer.head;
 }

 else
 {
  thePlayer.traverse = thePlayer.head;
  while(thePlayer.traverse->next != NULL)
    thePlayer.traverse = thePlayer.traverse->next;

  thePlayer.traverse->next = newNode;
  newNode->prev = thePlayer.traverse;
 }
 
 return thePlayer;
}

Player CreatePlayer(char* Name)
{
 Player thePlayer;

 int i;
 
 for(i = 0; i < 3; i++)         
 {                               
  thePlayer.name[i] = Name[i];
 }		

 thePlayer.head = NULL;
 
 return thePlayer;
}

Player LoadPlayer(char* Name)
{
 Player thePlayer;
 
 strcat(Name, ".plh");

 FILE* NewPlayer = fopen(Name,"r");
 
 if(!NewPlayer)
 {
  return CreatePlayer(Name);
 }
 
 int i;
 for(i = 0; i < 3; i++)         
 {                               
  thePlayer.name[i] = Name[i];
 }		
 
 int NextInt;
 int NextMoves;
 thePlayer.head = NULL;

 char nextLine[10];  
 
 i = fgetc(NewPlayer);
 
 while(i != EOF) 
 {
  fgets(nextLine,10,NewPlayer);
  NextInt = atoi(nextLine);
  fgets(nextLine,10,NewPlayer);
  NextMoves = atoi(nextLine);  
  thePlayer = add(thePlayer, NextInt, NextMoves);	
  i = fgetc(NewPlayer);
 }
 fclose(NewPlayer);
 
 return thePlayer;
}
