#include "score.h"


void freeScore(ScoreList theScore)
{
 theScore.Current = theScore.Head;

 while (theScore.Current != NULL) 
 { 	 
  theScore.Current = theScore.Head->next;
  free(theScore.Head);
  theScore.Head = theScore.Current;
 }	
}

ScoreList addName(ScoreList theScore, char* Name, int Gems, int Moves, char* Quote)
{
 ScNode* newNode = malloc(1000);

 newNode->Name = Name;
 newNode->Gems = Gems;
 newNode->Moves = Moves;
 newNode->Quote = Quote;
 
 	
 if (theScore.Head == NULL)
 {
  theScore.Head = newNode;
  theScore.Current = theScore.Head;

  theScore.Head->next = NULL;
  theScore.Head->prev = NULL;
 }

 else
 {
  theScore.Current = theScore.Head;
    
  while(theScore.Current->next != NULL)
  {
   theScore.Current = theScore.Current->next;
  }
  
   newNode->prev = theScore.Current;
   newNode->next = NULL;
   theScore.Current->next = newNode;
 }
 return theScore;
}

ScoreList CreateScoreList()
{
 FILE* Score = fopen("score.tbl", "r");

 char nextLine[40];
 ScoreList theScore;
 theScore.Head = NULL;
 
 char* Name = "   ";
 int Gems = 0;
 int Moves = 0;
 char* Quote = "                                          ";

 int i = fgetc(Score);
 
 while(i != EOF) 
 {
  Name = malloc(100);
  fgets(nextLine,40,Score);  	
  strcpy(Name, nextLine);
  Name[3] = '\0';
  fgets(nextLine,40,Score);  
  Gems = atoi(nextLine);
  fgets(nextLine,40,Score);
  Moves = atoi(nextLine);  
  fgets(nextLine,40,Score);  
  strcpy(Quote, nextLine);
  
  Quote[strlen(Quote) - 1] = '\0';
  theScore = addName(theScore, Name, Gems, Moves, Quote);
  i = fgetc(Score);
 }

 fclose(Score); 
 
 return theScore;
}

void WriteScores(ScoreList theScore)
{

 freeScore(theScore);			
}

void PrintScores(ScoreList theScore)
{
 theScore.Current = theScore.Head;

 printf("Name   Gems   Moves    Quote\n");
 while (theScore.Current != NULL) 
 { 	 
  printf("%s     %d     %d   \"%s\"\n", theScore.Current->Name, theScore.Current->Gems, theScore.Current->Moves, theScore.Current->Quote);  
  theScore.Current = theScore.Current->next;
 }
}

int main()
{
 ScoreList Mine = CreateScoreList();
 PrintScores(Mine);
 WriteScores(Mine);
 	
 return 1;	
}
