/*
Gem Slider [Alpha 0.4]
Michael Vendittelli 
Copyright 2003

*/

#ifndef gf_included_player_h
#define gf_included_player_h

#define LENGTH_MAX 24
#define HEIGHT_MAX 24

struct level
{
 char name[50];			//Name of the level.
 int NumberOfGems;		//How many Gems...actually this is determined by a counter function.  It is not a stored variable.
 int InMotion;			//If the level is currently in the middle of an action or if it is stopped.
 int ID;			//Consists of 8 digits.  (11)|(00)222333.  222 World Number, 333 Level Number.  00 are custom.  11 are in-game.  Not implemented.
 char Stage[LENGTH_MAX][HEIGHT_MAX][2];		//Levels are of the size 24 x 24.  There are two layers.  One is the stuff on top and the second is
 int Moves;            		//stuff below.  This is just in case a moveable object goes on top of another object...or gets sucked down.
};				//Also, The bottom row is not availabe for use at the moment.



typedef struct level Level;	//This was sort of unnecessary.  Meh, whatever.

Level OpenExit(Level theLevel);
//If NumberOfGems has been reduced to 0, this function gets called.  It finds and opens the exit.
Level Create(char* FileName);
//This stores the current Pass value (not implemented), the name and gets the level data from an external ".dat" file.
//It then goes through and counts the number of Gems.

#endif
