#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "level.h"

#ifndef gf_included_lvllist_h
#define gf_included_lvllist_h

typedef struct Llist LevelList;
typedef struct lnode LvlNode;

struct Llist
{
 LvlNode* Head;
 LvlNode* Tail;
 LvlNode* Current;
 
 int TotalGems;
};

struct lnode
{
 Level theLevel;
 
 LvlNode* next;
 LvlNode* prev;	
};



void freeLevels(LevelList theList);
LevelList addLevel(LevelList theList, Level nextLevel);
LevelList nextLevel(LevelList theList);
LevelList prevLevel(LevelList theList);
Level getLevel(LevelList theList);
LevelList CreateLevels();

#endif
